#!/bin/sh

input="$1"
output="$2"

fulldoi=`sed -n -e 's/^[[:space:]]*[dD][oO][iI][[:space:]]*=[[:space:]]*["{]\([^\}]\{1,\}\).*$/\1/p' "$input"`

esc_doi_re() {
	echo $1 | sed 's/\([\.\/]\)/\\\1/g;'
}

makeshortdoi() {
	curl -s http://shortdoi.org/$1\?format=json | sed -n -e '/"ShortDOI"[[:space:]]*:/s/^.*"\([^"]\{1,\}\)"[^"]*$/\1/p'
}

cp "$input" "$output"

for long in $fulldoi; do
	echo Querying "$long"
	short=`makeshortdoi "$long"`
	if [ "$short" = "" ]; then
		echo "Falied to query $long" >&2
		exit 1
	fi
    cmd="s/`esc_doi_re $long`/`esc_doi_re $short`/;"
    # echo "$cmd" >> "$1.shorten-cmd"
    sed -i.bak -e "$cmd" "$output"
	echo " ==>" "$short"
done
